﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Windows;
using Infragistics.Windows.Tiles;
using Infragistics.DragDrop;

namespace DD_Between_XamTilesControl
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Data1 = Data.GetData(10, 20, 50);
            Data2 = Data.GetData(10, 20, 50);

            DataContext = this;
        }

        public ObservableCollection<Data> Data1 { get; set; }
        public ObservableCollection<Data> Data2 { get; set; }

        private void DragSource_Drop(object sender, Infragistics.DragDrop.DropEventArgs e)
        {
            Data dragData = (e.DragSource as FrameworkElement).DataContext as Data;

            ObservableCollection<Data> dropCollection = (e.DropTarget as XamTilesControl).ItemsSource as ObservableCollection<Data>;
            ObservableCollection<Data> dragCollection = (Utilities.GetAncestorFromType(e.DragSource, typeof(XamTilesControl), false) as XamTilesControl).ItemsSource as ObservableCollection<Data>;

            dragCollection.Remove(dragData);
            dropCollection.Add(dragData);
            
        }
    }

    public class Data : INotifyPropertyChanged
    {
        private int val;
        private int val1;
        private int val2;
        private string label;

        public string Label
        {
            get { return label; }
            set
            {
                label = value;
                PropChanged("Label");
            }
        }

        public int Value
        {
            get { return val; }
            set
            {
                val = value;
                PropChanged("Value");
            }
        }

        public int Value1
        {
            get { return val1; }
            set
            {
                val1 = value;
                PropChanged("Value1");
            }
        }

        public int Value2
        {
            get { return val2; }
            set
            {
                val2 = value;
                PropChanged("Value2");
            }
        }

        public static ObservableCollection<Data> GetData(int points, int rangeStart, int rangeEnd)
        {
            ObservableCollection<Data> data = new ObservableCollection<Data>();
            Random r = new Random();
            for (int i = 0; i < points; i++)
            {
                data.Add(new Data
                {
                    Label = "Item " + i,
                    Value = r.Next(rangeStart, rangeEnd),
                    Value1 = r.Next(rangeStart, rangeEnd),
                    Value2 = r.Next(rangeStart, rangeEnd)
                });
            }

            return data;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }
}
